﻿using Sample.Models;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace Sample.Controllers
{
    public partial class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.data = DataSource;
            return View();
        }
        //public ActionResult Event(Syncfusion.JavaScript.DataManager dm)
        //{
        //    var DataSource = new NorthwindDataContext().OrdersViews.ToList();
        //    DataResult result = new DataResult();
        //    result.result = DataSource.Skip(dm.Skip).Take(dm.Take).ToList();
        //    result.count = DataSource.Count();
        //    return Json(result, JsonRequestBehavior.AllowGet);
        //}
       public ActionResult Update(OrdersView value)
        {
            var ds = new NorthwindDataContext();
            var query = from ord in ds.OrdersViews where ord.OrderID == value.OrderID select ord;
            foreach (OrdersView ord in query)
            {
                ord.OrderID = value.OrderID;
                ord.ShipCity = value.ShipCity;
                ord.ShipName = value.ShipName;
                ord.Freight = value.Freight;
            }
            ds.SubmitChanges();       
            return Json(value, JsonRequestBehavior.AllowGet);
        }
       public ActionResult Insert(OrdersView value)
        {            
            var ds = new NorthwindDataContext();
            
           
            ds.OrdersViews.InsertOnSubmit(value);
            ds.SubmitChanges();

            return Json(value, JsonRequestBehavior.AllowGet);
        }                            
        public ActionResult Delete(int key)
        {
            var ds = new NorthwindDataContext();
            var query = from ord in ds.OrdersViews where ord.OrderID == key select ord;

            foreach (OrdersView detail in query)
            ds.OrdersViews.DeleteOnSubmit(detail);
            ds.SubmitChanges();
            return Json(key, JsonRequestBehavior.AllowGet);
        }
        public ActionResult BatchUpdate(List<OrdersView> changed, List<OrdersView> added, List<OrdersView> deleted)
        {
             var db = new NorthwindDataContext();
           if (added != null)
            {
                foreach (OrdersView qspc in added)
                {
                    db.OrdersViews.InsertOnSubmit(qspc);
                }
            }
            else if (changed != null)
            {
            
            }
            else if (deleted != null)
            {
                foreach (OrdersView qspc in deleted)
                {
                  
                    var query = from ord in db.OrdersViews where ord.OrderID == qspc.OrderID select ord;

                    foreach (OrdersView detail in query)
                        db.OrdersViews.DeleteOnSubmit(detail);
                }
               
            }

            db.SubmitChanges();

            var data = db.OrdersViews.ToList();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        
        public class DataResult
        {
            public IEnumerable<OrdersView> result { get; set; }
            public int count { get; set; }
        }
    }

   
}
